--- With SERIAL
create table if not exists film_serial (
    id serial primary key,
    title character varying(255) not null
    -- …
);

truncate table film_serial;

insert into film_serial (title)
values
    ('Matrix'),
    ('Matrix Reloaded'),
    ('Matrix Revolutions'),
    ('Matrix Resurrections')
returning id, title;

select currval('film_serial_id_seq'::regclass);

-- 1. Side effect on global object
-- 2. Generated by the database (problem if distributed)
-- 3. You have to use `RETURNING …` to get it after `INSERT`

--- With UUID

create extension "uuid-ossp";
create table if not exists film_uuid (
    id uuid primary key default uuid_generate_v4(),
    title character varying(255) not null
);

truncate film_uuid;

insert into film_uuid (title)
values ('Matrix'),
       ('Matrix Reloaded'),
       ('Matrix Revolutions'),
       ('Matrix Resurrections')
returning id, title;

insert into film_uuid (id, title)
values ('4339890d-706f-4950-a862-542f288dca2e'::uuid, 'Matrix'),
       ('b4774c08-8be9-44a4-90aa-8b9af26a5c13'::uuid, 'Matrix Reloaded'),
       ('3f09a064-2f32-41b9-be24-94cc0b068a40'::uuid, 'Matrix Revolutions'),
       ('fae647ab-7c60-4e7c-b4a5-2188b3845f83'::uuid, 'Matrix Resurrections')
-- RETURNING id, title;

-- 1. usage of dedicated extension
-- 2. default value provided by a function, no global state
-- 3. Conflicting UUIDv4 (almost) impossible
-- 4. No need to `RETURNING …` if you've set it from your CODE